//
// Created by Ari Trachtenberg on 10/1/24, based on ChatGPT.
//
#include <iostream>
using namespace std;

#ifndef HW3_STAFF_HTTPCONNECT_H
#define HW3_STAFF_HTTPCONNECT_H

class HttpConnect {
 public:
  // METHODS
/**
 * Makes a request from https://[host]:[port]/[path] and returns the response.
 * @param host The host to which to connect.
 * @param port The port on that host to which to connect.
 * @param path The path to request on that host.
 * @return The response to the query.
 * @throws ConnectionError upon an error.
 */
  static string makeRequest(string host, string path, string port = "80");

  // SUBCLASSES
  class ConnectionError:public runtime_error {
   public:
    ConnectionError(string err): runtime_error(err) {}
  };
};

#endif //HW3_STAFF_HTTPCONNECT_H
